sample_table dw basse
             dw goal

S1_O1 equ (0 and 111000b) shl 5
S2_O1 equ (1 and 111000b) shl 5

S1_O2 equ (0 and 7)
S2_O2 equ (1 and 7)

EF_6 equ 5  ;jouer un sample sans loop, sur toute sa dure, pas d'hauteur

;pour chaque effet, on a une procdure d'init, donc il faut une table
effet_init dw 0
           dw 0
           dw 0
           dw 0
           dw 0
           dw init_eff3    ;c'est la meme proc d'init, car c'est presque =

melodie dw vox1

vox1 dw 2
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6

     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6

     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6

     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6
     db S1_O1, S1_O2, EF_6

     db S2_O1, S2_O2, EF_6
     db -1


;et enfin la routine qui fait les pr-calculs d'une voix, quand on
;passe  la note suivante (ou  la premire of course)
;attend dans cx un numro de voix (de 0  n-1)
new_note proc
        ;on fait les init generales
        mov    bx,cx
        shl    bx,1
        mov    bx,cs:[melodie+bx]
        mov    si,cs:[bx]
        cmp    byte ptr cs:[si+bx], -1
        jne    nn1
        mov    si,2
        mov    cs:[bx],si
nn1:    add    si,bx
        mov    ax,TAILLE_VOIX
        mul    cx
        mov    di,ax
        add    di,offset voix_contexte

        ;ensuite, on calcule le segment du sample
        mov    al,cs:[si]
        mov    ah,cs:[si+1]
        and    ah,7
        shr    al,2
        and    al,111000b
        or     al,ah
        xor    bx,bx
        mov    bl,al
        shl    bx,1
        mov    ax,cs:[bx+sample_table]
        mov    cs:[di+2],ax

        ;on met l'adresse de la proc effet
        mov    al,cs:[si+2]
        xor    bx,bx
        mov    bl,al
        shl    bx,1
        mov    ax,cs:[bx+effets_table]
        mov    cs:[di],ax

        ;et enfin, on appelle la proc d'init de l'effet choisi
        ;qui doit s'occuper d'incrementer la voix pour passer
        ;a la note suivante (ce qui permet d'avoir des datas
        ;de taille variable, ce qui reduit l'occupation memoire
        ;d'une melodie, c'est tout benefice (pour la pitite que j'ai
        ;mise la, on a environ 2000 lignes de 3 octets = 6000 octets,
        ;ce qui est court)
        xor    bx,bx
        mov    bl,cs:[si+2]
        shl    bx,1
        mov    si,cx
        shl    si,1
        mov    si,cs:[melodie+si]
        call   cs:[bx+offset effet_init]  ;c'est cette proc qui passe  la note
                                          ;suivante
        ret
endp

;pour l'effet 3, faut copier la longueur du sample dans voix_sample:[4]
;on rcupre l'adresse du sample, on lit la longueur, on la met  sa place
;(nota : en entre : di pointe sur le contexte voix, si pointe sur la
;voix elel-mme (ie la suite de notes))
;et aussi mettre 0 dans [6] (bordel de bug !)
init_eff3 proc
        mov    ds,cs:[di+2]
        mov    ax,ds:[0]
        mov    cs:[di+4],ax
        mov    word ptr cs:[di+6],0
        add    word ptr cs:[si],3
        ret
endp