;nota : les datas sont signes, ie 0=0 (et pas = 80 comme dans un sample 8b)
;donc, si on a des samples o 0=80h, faut tout soustraire, voil voil.

;les "contextes" des <> voix (8 should be enough for this time)
;la structure d'une voix :
;                   - mot 1 : l'adresse de la proc effet
;                   - mot 2 : le segment du sample
;                             (rappelons  ce propos, la structure d'un
;                             sample : mot 1 : la taille, mot 2 : le loop
;                             deb, mot 3 : le loop end, la suite = les datas)
;                   - mot 3-4 : l'offset dans le sample
;                               (mot 4, le dmot sert 'cause of l'incrment)
;                   - mot 5-6 : l'incrment
;                   - mot 7   : le nb d'octets  calculer (ie aprs avoir
;                               balanc tous ces octets, on s'arrte (ie on
;                               appelle la routine next_note en lui balanant
;                               si, et il se dmerde pour rinitialiser la
;                               voix, ie les mots 1-7 d'une voix).
;nota : les mots 3,4,5,6,7 sont bien videmment modifis par chaque effet
;on met 16 octets pour chaque voix,  voir si c'est assez ou trop + tard

TAILLE_VOIX equ 16*2    ;la taille d'un contexte de voix
voix_contexte dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
              dw 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0

nb_voix dw 1          ;le nb de voix pour la routine de mix.

mixer_nb_datas dw 0          ;le nb de words  calculer (diminu avec le t,
                             ;au cas o quand on fait un effet, et qu'on
                             ;a fini, et que le mix buffer est pas rempli
                             ;et que on passe  un autre effet (vogue la
                             ;galre !)

mix_buffer dw BUFF_TAILLE dup (0)  ;le buffer de mix (on mixe sur des words)

include melodie.inc

;les <> effets
;tout d'abord, la table des effets
effets_table dw 0
             dw 0
             dw 0
             dw 0
             dw 0
             dw offset effet6

;cette proc joue une note jusqu'au bout sans looper (don't
;care de savoir si c'est une croche, une blanche, so on.
;Elle joue le sample en entier.)
;=> on sait ou on en est par voix_contexte:[4], qui dit le nb
;d'octets du sample qui restent  calculer
effet6 proc
        push   cx
        mov    bp, mixer_nb_datas
        mov    ax,TAILLE_VOIX
        mul    cx
        mov    si,ax
        add    si,offset voix_contexte
        ;toutes les datas sont par cs:[si+XX]
        mov    ax, cs:[si+2]
        mov    ds,ax
        mov    dx,cs:[si+4]      ;si+4 = le nb d'octets qui restent a mettre
        mov    bx,cs:[si+6]      ;si+6 = l'offset dans le sample
        mov    di,mixer_nb
        sub    di,mixer_nb_datas
        shl    di,1
        jmp    e62
e61:    pop    cx
        call   new_note
        mov    mixer_nb_datas,bp
        mov    ax, TAILLE_VOIX
        mul    cx
        mov    si,ax
        jmp    cs:[si+offset voix_contexte]
e62:    or     bp,bp
        jz     e6f
        or     dx,dx            ;si dx=0, alors on a joue tout le sample
        je     e61              ;on doit donc mettre une new note
        xor    ah,ah
        mov    al,ds:[bx+6]
        sub    ax,80h
        inc    bx
        dec    dx
        add    cs:[di+mix_buffer],ax
        add    di,2
e64:    dec    bp
        jmp    e62
e6f:    pop    cx
        mov    cs:[si+4],dx
        mov    cs:[si+6],bx
        ret
endp

mixer_nb dw 0   ;le nb de datas  calculer
;attend dans cx un nb d'octets  foutre pour le player
mixer proc near
        mov    mixer_nb, cx
        ;on commence par clearer le buffer (on y fout des 0)
        mov    ax,cs
        mov    es,ax
        mov    di,offset mix_buffer
        cld
        xor    eax,eax  ;
        shr    cx,1     ;
        rep stosd       ;c'est cool, hein ? comme mthode
        adc    cx,cx    ;c'est du tran (le pmode-coder) (good guy)
        rep stosw       ;(un jour je ferai une daube avec son machin)
        ;ensuite, on appelle les <> voix
        xor    cx,cx
        mov    si,offset voix_contexte
mp1:    push   cx
        push   si
        mov    ax,mixer_nb
        mov    mixer_nb_datas, ax
        call   cs:[si]
        pop    si
        pop    cx
        add    si,TAILLE_VOIX
        inc    cx
        cmp    cx,nb_voix
        jne    mp1
        ;enfin, on recopie les datas mixes dans le buffer out dma
        mov    cx,mixer_nb
        call   calc_son
mpe:    ret
endp

;les vars pour la dma
dma_adress             dw 00,02,04,06,0C0h,0C4h,0c8h,0CCh
dma_count              dw 01,03,05,07,0C2h,0C6h,0CAh,0CEh
DMA_Read_status_Reg    dw 08,08,08,08,0D0h,0D0h,0D0h,0d0h
DMA_Write_status_Reg   dw 08,08,08,08,0D0h,0D0h,0D0h,0D0h
DMA_Write_requ_Reg     dw 09,09,09,09,0D2h,0D2h,0D2h,0D2h
DMA_Wr_single_mask_Reg dw 0Ah,0Ah,0Ah,0Ah,0D4h,0D4h,0D4h,0D4h
DMA_Wr_mode_Reg        dw 00Bh,00Bh,00Bh,00Bh,0D6h,0D6h,0D6h,0D6h
DMA_Clear_Flipflop     dw 00Ch,00Ch,00Ch,00Ch,0D8h,0D8h,0D8h,0D8h
DMA_Read_Temp_Reg      dw 00Dh,00Dh,00Dh,00Dh,0DAh,0DAh,0DAh,0DAh
DMA_Master_Clear       dw 00Dh,00Dh,00Dh,00Dh,0DAh,0DAh,0DAh,0DAh
DMA_Clear_Mask_Reg     dw 00Eh,00Eh,00Eh,00Eh,0DCh,0DCh,0DCh,0DCh
DMA_Wr_All_Mask_Reg    dw 00Fh,00Fh,00Fh,00Fh,0DEh,0DEh,0DEh,0DEh
DMA_Lower_Page         dw 087h,083h,081h,082h,000h,08Bh,089h,08Ah
DMA_Higher_Page        dw 0487h,0483h,0481h,0482h,00h,048Bh,0489h,048Ah
init_mixer proc
        ;on init les <> voix
        xor    cx,cx
im1:    call   new_note
        inc    cx
        cmp    cx,nb_voix
        jne    im1
        ;ensuite, on mixe un trois-quart buffer (pour que le dma
        ;et l'endroit o on mixe soient loignes de plusieurs
        ;octets, car sinon, a fait des clic (sanx to tran pour
        ;son source "timeless", sinon je sais pas comment j'aurais
        ;trouv ce machin)) (notons aussi qu'il faut balancer
        ;au dma et  la sb la taille du buffer - 1 (je sais
        ;pas pourquoi le -1, mais c'est comme a, sanx to tran
        ;once again)) (good coder ce tran, pas comme moi ;) )
        mov    cx,BUFF_TAILLE/2+BUFF_TAILLE/4
        call   mixer

        ;on init la dma
        mov    ax,cs
        mov    ds,ax
        ;masquer canal dma
        mov    ax,SB_DMA
        mov    bx,ax
        add    bx,ax
        mov    dx,[bx+dma_wr_single_mask_reg]
        add    al,4
        out    dx, al     ;0ah,al
        ;adresse de depart dma
        xor    eax,eax
        mov    ax,ds
        xor    ecx,ecx
        mov    cx,offset buff_son
        shl    eax,4
        add    ecx,eax
        mov    al,cl
        mov    dx,[bx+dma_adress]
        out    dx,al
        mov    al,ch
        out    dx,al
        rol    ecx,16
        mov    al,cl
        mov    dx,[bx+dma_lower_page]
        out    dx,al
        mov    al,ch
        mov    dx,[bx+dma_higher_page]
        out    dx,al
        ;clear flip-flop dma
        xor    eax,eax
        mov    dx,[bx+dma_clear_flipflop]
        out    dx,al
        ;definition du mode de transfert
        mov    ax,SB_DMA
        and    al,11b
        add    al,01011000b
        mov    dx,[bx+dma_wr_mode_reg]
        out    dx,al
        ;taille du bloc dma
        mov    ax,BUFF_TAILLE-1
        mov    dx,[bx+dma_count]
        out    dx,al
        mov    al,ah
        out    dx,al
        ;et on fait starter la sb (on joue un quart de buffer,
        ;comme a, on reste avec un demi-buffer d'quart avec
        ;l'endroit de calcul du mix, comme a, no problem)
        mov    cx,BUFF_TAILLE/4
        dec    cx
        mov    al,14h
        call   write_sb
        mov    al,cl
        call   write_sb
        mov    al,ch
        call   write_sb
        ;demasquer canal dma=>begin du sound
        mov    ax,SB_DMA
        mov    dx,[bx+dma_wr_single_mask_reg]
        out    dx,al

        ret
endp