;la fct d'init des vars globales SB_PORT, SB_DMA, SB_IRQ

;les vars globales
; includer dans tous les progs qui utilisent les routines plus bas
;detecter soit automatiquement par la var d'env BLASTER
;soit tapees a la main par l'user
SB_PORT dw 220h
SB_IRQ  dw 5
SB_DMA  dw 1

with_sound db 0

;renvoie fc=1 si with_sound=0  fc=0 si with_sound=1
with_sound_fct proc far
        cmp    with_sound,1
        ret
endp

sb_port_fct proc far
        mov    ax,SB_PORT
        ret
endp

sb_irq_fct proc far
        mov    ax,SB_IRQ
        ret
endp

sb_dma_fct proc far
        mov    ax,SB_DMA
        ret
endp

;la fameuse fonction find_sb !! (que j'ai finalement torchee,
;pour filer le prog au reste du monde. Hellos fly to Hulud.)
;renvoie fc=1 si pb de detection et que l'user choisi nosound
;fc=0 si BLASTER trouvee et clean ou si l'user tape a la main
;les vals (pas de verif. faites sur ces vals=>ca peut planter !)
fs_m1 db '- Sound blaster init -',10,13
      db '   Enter Port',10,13
      db ' 1 - 210h',10,13
      db ' 2 - 220h',10,13
      db ' 3 - 230h',10,13
      db ' 4 - 240h',10,13
      db ' 5 - 250h',10,13
      db ' 6 - 260h',10,13
      db ' 7 - 270h',10,13
      db ' 8 - 280h',10,13
      db ' n - Abort',10,13
      db 'Choice : $'
fs_m2 db 10,13,'   Enter IRQ',10,13
      db ' 1 - irq 2',10,13
      db ' 2 - irq 3',10,13
      db ' 3 - irq 5',10,13
      db ' 4 - irq 7',10,13
      db ' 5 - irq 10',10,13
      db ' n - Abort',10,13
      db 'Choice : $'
fs_m3 db 10,13,'   Enter DMA',10,13
      db ' 1 - dma 1',10,13
      db ' 2 - dma 5',10,13
      db ' 3 - dma 6',10,13
      db ' 4 - dma 7',10,13
      db ' n - Abort',10,13
      db 'Choice : $'
irq_valeur dw 2,3,5,7,10
dma_valeur dw 1,5,6,7
find_sb proc
        mov    ax,cs
        mov    ds,ax
        mov    dx,offset fs_m1
        mov    ah,9
        int    21h
fsb0:   xor    ax,ax
        int    16h
        cmp    al,'n'
        jz     fsbnul
        cmp    al,'N'
        jz     fsbnul
        cmp    al,'1'
        jb     fsb0
        cmp    al,'8'
        ja     fsb0
        xor    ah,ah
        sub    al,'0'
        shl    ax,4
        add    ax,200h
        mov    SB_PORT,ax
        mov    dx,offset fs_m2
        mov    ah,9
        int    21h
fsb1:   xor    ax,ax
        int    16h
        cmp    al,'n'
        jz     fsbnul
        cmp    al,'N'
        jz     fsbnul
        cmp    al,'1'
        jb     fsb1
        cmp    al,'5'
        ja     fsb1
        xor    ah,ah
        sub    al,'1'
        shl    ax,1
        mov    bx,ax
        mov    ax,cs:[bx+irq_valeur]
        mov    SB_IRQ,ax
        mov    dx,offset fs_m3
        mov    ah,9
        int    21h
fsb2:   xor    ax,ax
        int    16h
        cmp    al,'n'
        jz     fsbnul
        cmp    al,'N'
        jz     fsbnul
        cmp    al,'1'
        jb     fsb2
        cmp    al,'4'
        ja     fsb2
        xor    ah,ah
        sub    al,'1'
        shl    ax,1
        mov    bx,ax
        mov    ax,cs:[bx+dma_valeur]
        mov    SB_DMA,ax
        inc    with_sound
fsbnul: ret
endp
