old9 dd 0
old8 dd 0

new8 proc far
        push   ax
        inc    cs:show_screen
        mov    al,20h
        out    20h,al
        pop    ax
        iret
endp

new9 proc far
        push   ax
        in     al,60h
        cmp    al,81h
        setz   cs:all_over
        setz   cs:quit_by_keyboard
        mov    al,20h
        out    20h,al
        pop    ax
        iret
endp

include palette.inc

;on init le screen, on detournes les int 8 et 9
;on accelere le timer
init_screen proc
        call   init_cage
        mov    ax, 13h
        int    10h
        call   init_pal
        cli
        xor    ax,ax             ;
        mov    es,ax             ;
        mov    eax,es:[8*4]      ;
        mov    old8, eax         ;
        mov    eax,es:[9*4]      ;
        mov    old9, eax         ;
        mov    ax,cs             ;
        shl    eax,16            ;
        mov    ax,offset new8    ;
        mov    es:[8*4],eax      ;
        mov    ax,cs             ;
        shl    eax,16            ;on sauve les old int 8 et 9
        mov    ax,offset new9    ;et on met les notres (bad method
        mov    es:[9*4],eax      ;ici, faudrait utiliser l'int 21h)
        mov    al,36h     ;
        out    43h,al     ;
        mov    ax, 29829  ;1193180 / 40, car on veut 40 int par sec
        out    40h,al     ;
        mov    al,ah      ;on accelere le timer pour avoir 40
        out    40h,al     ;appels par seconde (on calcule 40 screens/s)
        sti
        ret
endp

;on close le screen, on remet les old int 8 et 9,
;on ralentit le timer
close_screen proc
        mov    ax,3
        int    10h
        cli
        xor    ax,ax
        mov    es,ax
        mov    eax,old8
        mov    es:[8*4],eax
        mov    eax,old9
        mov    es:[9*4],eax
        mov    al,36h
        out    43h,al
        xor    ax,ax
        out    40h,al
        out    40h,al
        sti
        ret
endp

TIME_PART1 equ (420)
TIME_PART2 equ (TIME_PART1+100)

temps_passe dw 0 ;TIME_PART1

include brese.inc

include part.inc

;cette fct est appelee tout au long du prog pour
;calculer des screens.
;elle appelle la routine qui faut, en fct du temps passe
calculate_screen proc
        cmp    temps_passe, TIME_PART1
        jb     cs11
        cmp    temps_passe, TIME_PART1+TIME_PART2
        jb     cs12
        mov    all_over,1
        ret
cs11:   call   part1
        mov    ax,inc_valeur
        add    temps_part1,ax
        jmp    csf
cs12:   call   part2
        mov    ax,inc_valeur
        add    temps_part2,ax
;        jmp    csf
csf:    mov    ax,inc_valeur
        add    temps_passe,ax
        ret
endp

;on se contente de recopier le segment 'ecran' a l'ecran (!)
put_screen proc
        xor    si,si
        push   20
        call   random
        sub    ax,10
        mov    di,ax
        push   20
        call   random
        sub    ax,10
        imul   ax,ax,320
        add    di,ax
        and    di,not 3
        mov    ax,0a000h
        mov    es,ax
        mov    ax,ecran
        mov    ds,ax
        cld
        mov    cx,16000
        rep movsd
        ret
endp

;on clear le screen
clear_screen proc
        xor    di,di
        mov    ax,ecran
        mov    es,ax
        cld
        xor    eax,eax
        mov    cx,16000
        rep stosd
        ret
endp