color dw 0

ini_bre proc
        mov    color,128
        ret
endp

bresenham   proc near a,b,c,d:word
         enter 0,0
        ;retaillons !

        test   a,8000h
        je     b_1
        test   c,8000h
        je     b_0
        ;a<0 et c<0 => hors screen
        leave
        ret
b_0:    ;a<0  c>=0  => forcer a  0
;
;             x
;             (c,d)
;       x (0,x)
;   x
;   (a,b)
;
;   -a / c = (b - x) /  (x-d)
;  a1 = -a /c
;
;  x * a1 - d*a1 = b - x
;
;  x = (b + d * a1 ) / (a1 + 1)
        cmp    c,0
        jne    b_00
        mov    ax,c
        mov    a,ax
        mov    ax,d
        mov    b,ax
        jmp    b_3
b_00:
        mov    ax,a
        neg    ax
        cwd
        idiv   c
        mov    cx,ax
        imul   d
        add    ax,b
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    b,ax
        mov    a,0

b_1:    cmp    a,320
        jb     b_3
        cmp    c,320
        jb     b_2
        ;a>=320 et c>=320 => hors screen
        leave
        ret
b_2:    ;a>=320 c<320 => forcer a  319
;
;             x
;             (a,b)
;       x (319,x)
;   x
;   (c,d)
;
;   (319-c) / (a-319) = (d - x) /  (x-b)
;  a1 = (319-c) / (a-319)
;
;  x * a1 - b*a1 = d - x
;
;  x = (d + b * a1 ) / (a1 + 1)
        cmp    c,319
        jne    b_20
        mov    ax,c
        mov    a,ax
        mov    ax,d
        mov    b,ax
        jmp    b_3
b_20:
        mov    ax,319
        sub    ax,c
        cwd
        mov    cx,a
        sub    cx,319
        idiv   cx
        mov    cx,ax
        imul   b
        add    ax,d
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    b,ax
        mov    a,319

b_3:    ;en horizontal, tout pareil sauf a<=>b et c<=>d

        test   b,8000h
        je     _b_1
        test   d,8000h
        je     _b_0
        leave
        ret
_b_0:   cmp    d,0
        jne    _b_00
        mov    ax,d
        mov    b,ax
        mov    ax,c
        mov    a,ax
        jmp    _b_3
_b_00:  mov    ax,b
        neg    ax
        cwd
        idiv   d
        mov    cx,ax
        imul   c
        add    ax,a
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    a,ax
        mov    b,0
_b_1:   cmp    b,200
        jb     _b_3
        cmp    d,200
        jb     _b_2
        leave
        ret
_b_2:   cmp    d,199
        jne    _b_20
        mov    ax,d
        mov    b,ax
        mov    ax,c
        mov    a,ax
        jmp    _b_3
_b_20:  mov    ax,199
        sub    ax,d
        cwd
        mov    cx,b
        sub    cx,199
        idiv   cx
        mov    cx,ax
        imul   a
        add    ax,c
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    a,ax
        mov    b,199
_b_3:

        test   c,8000h
        je     c_1
        test   a,8000h
        je     c_0
        ;c<0 et a<0 => hors screen
        leave
        ret
c_0:    ;c<0  a>=0  => forcer c  0
;
;             x
;             (a,b)
;       x (0,x)
;   x
;   (c,d)
;
;   -c / a = (d - x) /  (x-b)
;  a1 = -c /a
;
;  x * a1 - b*a1 = d - x
;
;  x = (d + b * a1 ) / (a1 + 1)
        cmp    a,0
        jne    c_00
        mov    ax,a
        mov    bx,b
        mov    c,ax
        mov    d,bx
        jmp    c_3
c_00:
        mov    ax,c
        neg    ax
        cwd
        idiv   a
        mov    cx,ax
        imul   b
        add    ax,d
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    d,ax
        mov    c,0

c_1:    cmp    c,320
        jb     c_3
        cmp    a,320
        jb     c_2
        ;c>=320 et a>=320 => hors screen
        leave
        ret
c_2:    ;c>=320 a<320 => forcer c  319
;
;             x
;             (c,d)
;       x (319,x)
;   x
;   (a,b)
;
;   (319-a) / (c-319) = (b - x) /  (x-d)
;  a1 = (319-a) / (c-319)
;
;  x * a1 - d*a1 = b - x
;
;  x = (b + d * a1 ) / (a1 + 1)
        cmp    a,319
        jne    c_20
        mov    ax,a
        mov    c,ax
        mov    ax,b
        mov    d,ax
        jmp    c_3
c_20:
        mov    ax,319
        sub    ax,a
        cwd
        mov    cx,c
        sub    cx,319
        idiv   cx
        mov    cx,ax
        imul   d
        add    ax,b
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    d,ax
        mov    c,319

c_3:    ;idem mais a<=>b et c<=>d et 320=>200 et 319=>199

        test   d,8000h
        je     _c_1
        test   b,8000h
        je     _c_0
        leave
        ret
_c_0:   cmp    b,0
        jne    _c_00
        mov    ax,b
        mov    bx,a
        mov    d,ax
        mov    c,bx
        jmp    _c_3
_c_00:  mov    ax,d
        neg    ax
        cwd
        idiv   b
        mov    cx,ax
        imul   a
        add    ax,c
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    c,ax
        mov    d,0
_c_1:   cmp    d,200
        jb     _c_3
        cmp    b,200
        jb     _c_2
        leave
        ret
_c_2:   cmp    b,199
        jne    _c_20
        mov    ax,b
        mov    d,ax
        mov    ax,a
        mov    c,ax
        jmp    _c_3
_c_20:  mov    ax,199
        sub    ax,b
        cwd
        mov    cx,d
        sub    cx,199
        idiv   cx
        mov    cx,ax
        imul   c
        add    ax,a
        ;adc    dx,0
        cwd
        inc    cx
        idiv   cx
        mov    c,ax
        mov    d,199
_c_3:

        mov    ax,a
        mov    bx,b
        mov    cx,c
        mov    dx,d


        push   es
        push   di
        push   si
        push   bp
        push   ax
        push   bx
        mov    bx,4340h
        sub    cx,ax
mov ax,321
        jns    deltax_ok
        neg    cx
sub ax,1*2
        mov    bl,48h
deltax_ok:
        mov    bp,sp
        sub    dx,ss:[bp]
        jns    deltay_ok
        neg    dx
sub ax,320*2
        mov    bh,4bh
deltay_ok:
        mov    si,dx
        or     si,cx
        jne    ok
        pop    bx
        pop    ax
        jmp    fini
ok:
;40 inc ax
;43 inc bx
;48 dec ax
;4b dec bx
        mov    word ptr cs:dist_pos+2,ax

        cmp    cx,dx
        jge    deltax_grand
        xchg   cx,dx
        ;mov    bl,90h
        mov    ax,320
        cmp    bh,43h
        je     okk1
        neg    ax
okk1:   jmp    constantes
deltax_grand:
        ;mov    bh,90h
        mov    ax,1
        cmp    bl,48h
        jne    constantes
        neg    ax
constantes:
        mov    word ptr cs:dist_neg+2,ax
        shl    dx,1
        mov    di,dx
        sub    dx,cx
        mov    bp,dx
        mov    si,bp
        sub    si,cx
        pop    bx
        pop    ax
        mov    dx,320
        xchg ax,bx
        mul dx
        add bx,ax
        mov ax,ecran
        mov es,ax
        mov ax,cs:color
loop_p: ;putpixel
        inc al
        setz ah
        sub  al,ah
;        jnz llpp
;        dec al
;llpp:
        mov byte ptr es:[bx],al

        ;fin putpixel
        or     bp,bp
        jns    dist_pos
dist_neg:
add bx,3200
        ;inc    ax
        ;inc    bx
        add    bp,di
        dec    cx
        jne    loop_p
        mov    byte ptr cs:color,al
        jmp    fini
dist_pos:
add bx,3200
       ; inc    ax
       ; inc    bx
        add    bp,si
        dec    cx
        jne    loop_p
        mov    byte ptr cs:color,al
fini:   pop    bp
        pop    si
        pop    di
        pop    es
        leave
        ret
endp

init_pal proc
        mov    dx,03c8h
        mov    al,128
        out    dx,al
        inc    dx

        mov    bl,63
        mov    bh,63
        mov    si,16
_o1:    mov    al,bl
        out    dx,al
        mov    al,bh
        out    dx,al
        xor    al,al
        out    dx,al
        dec    bh
        dec    bh
        dec    si
        jnz    _o1

        xor    ch,ch
        mov    si,16
_o2:    mov    al,bl
        out    dx,al
        mov    al,bh
        out    dx,al
        mov    al,ch
        out    dx,al
        dec    bh
        dec    bh
       ; dec    bl
        dec    bl
        dec    bl
        inc    ch
        inc    ch
        inc    ch
        inc    ch
        dec    si
        jnz    _o2

        inc    bh
        inc    bh
        inc    bl
        inc    bl
        dec    ch
        dec    ch
        dec    ch
        dec    ch

        mov    si,127-16-16 ;32+32+32+32+32+31
_o3:    mov    al,bl
        out    dx,al
        mov    al,bh
        out    dx,al
        mov    al,ch
        out    dx,al
        dec    si
        jne    _o3
        ret
endp