;la mlodie, c'est des voix. Une voix, c'est une suite de notes.
;une note, c'est un numro de sample, un effet  appliquer sur ce
;sample, une dure (noire, croche), une hauteur.
;faudrait aussi dfinir un volume, mais bon. On verra + tard si faut
;modifier a ou pas

;pour les hauteurs, c'est l'incrment qui change, d'o cette table
;on sait en musique que pour aller d'une note au demi-ton superieur
;ou inferieur faut modifier par racine 12eme de 2.
;Comment ?
;bah, une note, c'est des octets qui se suivent.
;quand on lit une note, on lit octet par octet, et on fout ca
;dans le buffer de sortie.
;Bon.
;bah pour aller un demi-ton au dessus, on increment pas de 1, mais
;de racine 12eme de 2 (=1.05946309...), et pour un demi-ton
;en-dessous, on prend l'inverse (=0.94387431...) et on recommence
;de proche en proche.
;D'ou cette table, qu'est en 32b firgule fixe a 16b (ie on prend
;l'increment, et on multiplie par 2^16, et hop, on a l'icrement
;en virgule fixe (1.05946309*2^16=69433 environs, comme marque
;a la ligne xxxx)
RAC_TAB dd 32768  ;1/2  ; 0
        dd 34716        ; 1
        dd 36781        ; 2
        dd 38968        ; 3
        dd 41285        ; 4
        dd 43740        ; 5
        dd 46341        ; 6
        dd 49097        ; 7
        dd 52016        ; 8
        dd 55109        ; 9
        dd 58386        ;10
        dd 61858        ;11
        dd 1*65536 ;1   ;12
        dd 69433        ;13   ;xxxx
        dd 73562        ;14
        dd 77936        ;15
        dd 82570        ;16
        dd 87480        ;17
        dd 92682        ;18
        dd 98193        ;19
        dd 104032       ;20
        dd 110218       ;21
        dd 116772       ;22
        dd 123715       ;23
        dd 131072  ;2   ;24

;les <> notes sur 2 octaves (pour l'instant)
;nota : ces valeurs servent juste d'indice dans la table
;precedentes, donc ca veut dire que N_DO1 c'est le sample
;joue a sa vitesse normale (ie octet par octet, sans en sauter
;ni en doubler)
N_DO    equ  0
N_REb   equ  1
N_RE    equ  2
N_MIb   equ  3
N_MI    equ  4
N_FA    equ  5
N_SOLb  equ  6
N_SOL   equ  7
N_LAb   equ  8
N_LA    equ  9
N_SIb   equ 10
N_SI    equ 11
N_DO1   equ 12
N_RE1b  equ 13
N_RE1   equ 14
N_MI1b  equ 15
N_MI1   equ 16
N_FA1   equ 17
N_SOL1b equ 18
N_SOL1  equ 19
N_LA1b  equ 20
N_LA1   equ 21
N_SI1b  equ 22
N_SI1   equ 23
N_DO2   equ 24

;les dures des notes
;nota : c'est juste pour se rappeler. Toute valeur de 1 a 31 est ok
;(shl 3 because le format d'une note, voir + bas)
N_BLANCHE  equ ((31  ) shl 3)
N_NOIREP   equ ((15+8) shl 3)
N_NOIRE    equ ((15  ) shl 3)
N_CROCHEP  equ ((7+4 ) shl 3)
N_CROCHE   equ ((7   ) shl 3)
N_DCROCHEP equ ((3+2 ) shl 3)
N_DCROCHE  equ ((3   ) shl 3)
N_QCROCHE  equ ((1   ) shl 3)

;le tempo
N_TEMPO dw 120

;bon, voyons maintenant la structure d'une note :
;         octet 1 : bits 0-4 :la hauteur du son
;         octet 1 bits 5-7 + octet 2 bits 0-2 : le numro du sample
;         octet 2 bits 3-7 : la dure du son
;         octet 3 : l'effet (pour l'instant tous les bits servent)
; + si les effets ont besoin d'octet en +, c'est  chaque proc d'init
; d'effet  le grer et  renvoyer un pointeur sur la suite de la mlodie

;la table des samples (64 maxi)
;c'est les adresses des <> samples
sample_table dw la
             dw poum
             dw pim
             dw pshuit
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la
             dw la

;les equ pour utiliser + simplement
;S1 pour dire sample 1, etc... O1, pour dire que c'est dans l'octet 1,
;ces machins servent juste pour pas avoir a se rappeler les and, shl et
;machins chiants de ce genre
S1_O1 equ (0 and 111000b) shl 5
S2_O1 equ (1 and 111000b) shl 5
S3_O1 equ (2 and 111000b) shl 5
S4_O1 equ (3 and 111000b) shl 5
S5_O1 equ (4 and 111000b) shl 5
S6_O1 equ (5 and 111000b) shl 5
S7_O1 equ (6 and 111000b) shl 5
S8_O1 equ (7 and 111000b) shl 5
S9_O1 equ (8 and 111000b) shl 5
S10_O1 equ (9 and 111000b) shl 5
S11_O1 equ (10 and 111000b) shl 5
S12_O1 equ (11 and 111000b) shl 5
S13_O1 equ (12 and 111000b) shl 5
S14_O1 equ (13 and 111000b) shl 5
S15_O1 equ (14 and 111000b) shl 5
S16_O1 equ (15 and 111000b) shl 5
S17_O1 equ (16 and 111000b) shl 5
S18_O1 equ (17 and 111000b) shl 5
S19_O1 equ (18 and 111000b) shl 5
S20_O1 equ (19 and 111000b) shl 5
S21_O1 equ (20 and 111000b) shl 5
S22_O1 equ (21 and 111000b) shl 5
S23_O1 equ (22 and 111000b) shl 5
S24_O1 equ (23 and 111000b) shl 5
S25_O1 equ (24 and 111000b) shl 5
S26_O1 equ (25 and 111000b) shl 5
S27_O1 equ (26 and 111000b) shl 5
S28_O1 equ (27 and 111000b) shl 5
S29_O1 equ (28 and 111000b) shl 5
S30_O1 equ (29 and 111000b) shl 5
S31_O1 equ (30 and 111000b) shl 5
S32_O1 equ (31 and 111000b) shl 5
S33_O1 equ (32 and 111000b) shl 5
S34_O1 equ (33 and 111000b) shl 5
S35_O1 equ (34 and 111000b) shl 5
S36_O1 equ (35 and 111000b) shl 5
S37_O1 equ (36 and 111000b) shl 5
S38_O1 equ (37 and 111000b) shl 5
S39_O1 equ (38 and 111000b) shl 5
S40_O1 equ (39 and 111000b) shl 5
S41_O1 equ (40 and 111000b) shl 5
S42_O1 equ (41 and 111000b) shl 5
S43_O1 equ (42 and 111000b) shl 5
S44_O1 equ (43 and 111000b) shl 5
S45_O1 equ (44 and 111000b) shl 5
S46_O1 equ (45 and 111000b) shl 5
S47_O1 equ (46 and 111000b) shl 5
S48_O1 equ (47 and 111000b) shl 5
S49_O1 equ (48 and 111000b) shl 5
S50_O1 equ (49 and 111000b) shl 5
S51_O1 equ (50 and 111000b) shl 5
S52_O1 equ (51 and 111000b) shl 5
S53_O1 equ (52 and 111000b) shl 5
S54_O1 equ (53 and 111000b) shl 5
S55_O1 equ (54 and 111000b) shl 5
S56_O1 equ (55 and 111000b) shl 5
S57_O1 equ (56 and 111000b) shl 5
S58_O1 equ (57 and 111000b) shl 5
S59_O1 equ (58 and 111000b) shl 5
S60_O1 equ (59 and 111000b) shl 5
S61_O1 equ (60 and 111000b) shl 5
S62_O1 equ (61 and 111000b) shl 5
S63_O1 equ (62 and 111000b) shl 5
S64_O1 equ (63 and 111000b) shl 5

S1_O2 equ (0 and 7)
S2_O2 equ (1 and 7)
S3_O2 equ (2 and 7)
S4_O2 equ (3 and 7)
S5_O2 equ (4 and 7)
S6_O2 equ (5 and 7)
S7_O2 equ (6 and 7)
S8_O2 equ (7 and 7)
S9_O2 equ (8 and 7)
S10_O2 equ (9 and 7)
S11_O2 equ (10 and 7)
S12_O2 equ (11 and 7)
S13_O2 equ (12 and 7)
S14_O2 equ (13 and 7)
S15_O2 equ (14 and 7)
S16_O2 equ (15 and 7)
S17_O2 equ (16 and 7)
S18_O2 equ (17 and 7)
S19_O2 equ (18 and 7)
S20_O2 equ (19 and 7)
S21_O2 equ (20 and 7)
S22_O2 equ (21 and 7)
S23_O2 equ (22 and 7)
S24_O2 equ (23 and 7)
S25_O2 equ (24 and 7)
S26_O2 equ (25 and 7)
S27_O2 equ (26 and 7)
S28_O2 equ (27 and 7)
S29_O2 equ (28 and 7)
S30_O2 equ (29 and 7)
S31_O2 equ (30 and 7)
S32_O2 equ (31 and 7)
S33_O2 equ (32 and 7)
S34_O2 equ (33 and 7)
S35_O2 equ (34 and 7)
S36_O2 equ (35 and 7)
S37_O2 equ (36 and 7)
S38_O2 equ (37 and 7)
S39_O2 equ (38 and 7)
S40_O2 equ (39 and 7)
S41_O2 equ (40 and 7)
S42_O2 equ (41 and 7)
S43_O2 equ (42 and 7)
S44_O2 equ (43 and 7)
S45_O2 equ (44 and 7)
S46_O2 equ (45 and 7)
S47_O2 equ (46 and 7)
S48_O2 equ (47 and 7)
S49_O2 equ (48 and 7)
S50_O2 equ (49 and 7)
S51_O2 equ (50 and 7)
S52_O2 equ (51 and 7)
S53_O2 equ (52 and 7)
S54_O2 equ (53 and 7)
S55_O2 equ (54 and 7)
S56_O2 equ (55 and 7)
S57_O2 equ (56 and 7)
S58_O2 equ (57 and 7)
S59_O2 equ (58 and 7)
S60_O2 equ (59 and 7)
S61_O2 equ (60 and 7)
S62_O2 equ (61 and 7)
S63_O2 equ (62 and 7)
S64_O2 equ (63 and 7)

;les effets
;ces equ servent pour jouer le bon effet.
;on les utilise comme offset dans la table "effet_init" du present
;fichier et aussi dans la table "effets_table" du fichier mixer.inc
;c'est un decoupage farfelu, mais c'est comme ca.
EF_1 equ 0  ;jouer un sample en loop, avec hauteur
EF_2 equ 1  ;idem 1 mais en satur
EF_3 equ 2  ;joue un sample sans loop, sans hauteur
EF_4 equ 3  ;fait du silence
EF_5 equ 4  ;jouer un sample sans loop, avec hauteur

;pour chaque effet, on a une procdure d'init, donc il faut une table
effet_init dw no_init
           dw no_init
           dw init_eff3
           dw no_init
           dw no_init

;la melodie, ie les adresses des <> voix.
melodie dw vox1
        dw vox2
        dw vox3
        dw vox4
;        dw vox5
;        dw vox6
;        dw vox7
;        dw vox8

;et voici la mlodie des <> voix
;le 1er mot dit la pos courante dans la mlodie (commence  2)
;(y change avec le temps)
;le reste c'est les notes qui se succedent.
;nota : une voix se termine par -1, pour dire qu'on doit repartir
;au debut (on pourrait dire que la voix est finie, et qu'il faut
;faire comme si on demandait du silence, mais bon...)
;  a noter que c'est mauvais de prendre -1, car il se peut tout a fait
;  que le 1er octet d'une note valide soit -1, mais bon, pour l'instant
;  le cas s'est pas produit (faudrait que j'utilise 64 samples et que je
;  joue un N_DO2, ce qui n'est ici pas le cas, donc on laisse comme ca).
vox1 dw 2
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_DO2  or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_NOIRE, EF_5
     db N_FA1 or S1_O1, S1_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S1_O1, S1_O2 or N_BLANCHE, EF_5


     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_LA1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S2_O1, S2_O2 or N_CROCHEP, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_DCROCHE, EF_5
     db N_RE1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5


     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db -1

vox2 dw 2
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5

     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_NOIREP, EF_5


     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_NOIREP, EF_5


     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_NOIRE, EF_4

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db -1

n equ 0
mn equ 0
vox3 dw 2
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_NOIRE, EF_4
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5

;     db 0, N_NOIRE, EF_4
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5

     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5

     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5

     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5

     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5
     db N_MI1 or S3_O1, S3_O2 or N_BLANCHE, EF_5


     db 0, N_NOIRE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_NOIRE, EF_4
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5

     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_BLANCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_NOIRE, EF_5


     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db -1

vox4 dw 2
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5


     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_BLANCHE, EF_5
     db 0, N_CROCHE, EF_4
     db 0, N_NOIREP, EF_4
     db N_MI1 or S4_O1, S4_O2 or N_CROCHE, EF_5


     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4

     db 0, N_BLANCHE, EF_4
     db 0, N_NOIRE, EF_4

     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_SOL1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_MI1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_DO2  or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_LA1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_SOL1 or S2_O1, S2_O2 or N_NOIRE, EF_5
     db N_FA1 or S3_O1, S3_O2 or N_CROCHEP, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_DCROCHE, EF_5
     db N_RE1 or S3_O1, S3_O2 or N_CROCHE, EF_5
     db N_MI1 or S1_O1, S1_O2 or N_CROCHE, EF_5
     db N_DO1 or S2_O1, S2_O2 or N_BLANCHE, EF_5

     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db 0, N_BLANCHE, EF_4
     db -1

;et enfin la routine qui fait les pr-calculs d'une voix, quand on
;passe  la note suivante (ou  la premire of course)
;attend dans cx un numro de voix (de 0  n-1)
new_note proc
        ;on fait les init generales
        mov    bx,cx
        shl    bx,1
        mov    bx,cs:[melodie+bx]
        mov    si,cs:[bx]
        cmp    byte ptr cs:[si+bx], -1
        jne    nn1
        mov    si,2
        mov    cs:[bx],si
nn1:    add    si,bx
        mov    ax,TAILLE_VOIX
        mul    cx
        mov    di,ax
        add    di,offset voix_contexte

        ;d'abord la hauteur d'un son (ie l'increment dans le sample)
        mov    al,cs:[si]
        and    ax,31
        shl    ax,2
        mov    bx,ax
        mov    eax,cs:[RAC_TAB+bx]
        mov    cs:[di+8],eax

        ;ensuite, on part du debut du sample
        xor    eax,eax
        mov    cs:[di+4],eax

        ;ensuite, on calcule le segment du sample
        mov    al,cs:[si]
        mov    ah,cs:[si+1]
        and    ah,7
        shr    al,2
        and    al,111000b
        or     al,ah
        xor    bx,bx
        mov    bl,al
        shl    bx,1
        mov    ax,cs:[bx+sample_table]
        mov    cs:[di+2],ax

        ;on met l'adresse de la proc effet
        mov    al,cs:[si+2]
        xor    bx,bx
        mov    bl,al
        shl    bx,1
        mov    ax,cs:[bx+effets_table]
        mov    cs:[di],ax

        ;on dit combien de mots faut calculer
        mov    ax,15
        mov    bx,11025
        mul    bx
        mov    bx,N_TEMPO
        shrd   ax,dx,2
        shr    dx,2
        div    bx
        mov    bx,ax
        mov    al,cs:[si+1]
        shr    al,3
        inc    al
        xor    ah,ah
        mul    bx
        mov    cs:[di+12],ax

        ;et enfin, on appelle la proc d'init de l'effet choisi
        ;qui doit s'occuper d'incrementer la voix pour passer
        ;a la note suivante (ce qui permet d'avoir des datas
        ;de taille variable, ce qui reduit l'occupation memoire
        ;d'une melodie, c'est tout benefice (pour la pitite que j'ai
        ;mise la, on a environ 2000 lignes de 3 octets = 6000 octets,
        ;ce qui est court)
        xor    bx,bx
        mov    bl,cs:[si+2]
        shl    bx,1
        mov    si,cx
        shl    si,1
        mov    si,cs:[melodie+si]
        call   cs:[bx+offset effet_init]  ;c'est cette proc qui passe  la note
                                          ;suivante
        ret
endp

;pour l'effet 3, faut copier la longueur du sample dans voix_sample:[4]
;on rcupre l'adresse du sample, on lit la longueur, on la met  sa place
;(nota : en entre : di pointe sur le contexte voix, si pointe sur la
;voix elel-mme (ie la suite de notes))
;et aussi mettre 0 dans [6] (bordel de bug !)
init_eff3 proc
        mov    ds,cs:[di+2]
        mov    ax,ds:[0]
        mov    cs:[di+4],ax
        mov    word ptr cs:[di+6],0
        add    word ptr cs:[si],3
        ret
endp

;rien de particulier a faire, on incremente juste pour passer
;a la note suivante
no_init proc
        add    word ptr cs:[si],3
        ret
endp