public deb0

extrn with_sound_fct : far
extrn sb_dma_fct : far
extrn sb_irq_fct : far
extrn sb_port_fct : far
extrn ecran_fct : far

include la.son
include poum.son
include pim.son
include pshuit.son

code2 segment para 'code'
.486
assume cs:code2

deb0:   call   ecran_fct
        mov    ecran,ax
        call   init_screen
        call   init_sound
deb1:   cmp    all_over, 1
        jz     fin
        cmp    show_screen, 0
        jz     deb1
        cli
        mov    ax,show_screen
        mov    inc_valeur, ax
        mov    show_screen, 0
        sti
        call   calculate_screen
        call   put_screen
        jmp    deb1
fin:    call   close_sound
        call   close_screen
        ;mov    ax,4c00h
        ;int    21h
        cmp    quit_by_keyboard,1
        cmc
        retf

quit_by_keyboard db 0
all_over db 0
show_screen dw 0
inc_valeur dw 0

include sound.inc
include screen.inc

ecran dw 0

ends

.286

end deb0