timing dw 0

old9 dd 0
old8 dd 0

new8 proc far
        push   ax
        inc    cs:show_screen
        mov    al,20h
        out    20h,al
        pop    ax
        iret
endp

new9 proc far
        push   ax
        in     al,60h
        cmp    al,81h
        setz   cs:all_over
        setz   cs:quit_by_keyboard
        mov    al,20h
        out    20h,al
        pop    ax
        iret
endp

include sinustab.sin
include random.inc
include star.inc
include bars.inc
include scroll.inc
include messies.inc
include part.inc

palette db 60,60,60
        db 50,50,50
        db 40,40,40
        db 30,30,30

        db 5,0,0
        db 15,15,0
        db 20,30,0
        db 25,45,0
        db 30,60,0
        db 30,60,0
        db 25,45,0
        db 20,30,0
        db 15,15,0
        db 5,0,0

        db 5,0,0
        db 15,15,17
        db 20,30,32
        db 25,45,47
        db 30,60,63
        db 30,60,63
        db 25,45,47
        db 20,30,32
        db 15,15,17
        db 5,0,0

        db 5,0,0
        db 15,0,17
        db 20,0,32
        db 25,0,47
        db 30,0,63
        db 30,0,63
        db 25,0,47
        db 20,0,32
        db 15,0,17
        db 5,0,0

        db 0,0,0
        db 0,0,17
        db 0,0,32
        db 0,0,47
        db 0,0,63
        db 0,0,63
        db 0,0,47
        db 0,0,32
        db 0,0,17
        db 0,0,0

        db 0,0,0
        db 0,20,17
        db 0,30,32
        db 0,40,47
        db 0,50,63
        db 0,50,63
        db 0,40,47
        db 0,30,32
        db 0,20,17
        db 0,0,0

        db 0,0,0
        db 0,20,1
        db 0,30,3
        db 0,40,4
        db 0,50,6
        db 0,50,6
        db 0,40,4
        db 0,30,3
        db 0,20,1
        db 0,0,0

        db 63,0,0
        db 63,4,0
        db 63,8,0
        db 63,12,0
        db 63,16,0
        db 63,20,0
        db 63,24,0
        db 63,28,0
        db 63,32,0
        db 63,35,0
        db 63,39,0
        db 63,43,0
        db 63,47,0
        db 63,51,0
        db 63,55,0
        db 63,59,0
        db 63,63,0
        db 63,59,0
        db 63,51,0
        db 63,47,0
        db 63,43,0
        db 63,39,0
        db 63,35,0
        db 63,32,0
        db 63,28,0
        db 63,24,0
        db 63,20,0
        db 63,16,0
        db 63,12,0
        db 63,8,0
        db 63,4,0
        db 63,0,0

        db 63,25,43

init_pal proc
        mov    dx,03c8h
        mov    al,1
        out    dx,al
        inc    dx
        mov    ax,cs
        mov    ds,ax
        mov    si,offset palette
        mov    cx,(4+6*10+32+1)*3
        rep outsb
        ret
endp

init_screen proc
        mov    ax, 13h
        int    10h
        call   init_pal
        call   init_mess
        cli
        xor    ax,ax             ;
        mov    es,ax             ;
        mov    eax,es:[8*4]      ;
        mov    old8, eax         ;
        mov    eax,es:[9*4]      ;
        mov    old9, eax         ;
        mov    ax,cs             ;
        shl    eax,16            ;
        mov    ax,offset new8    ;
        mov    es:[8*4],eax      ;
        mov    ax,cs             ;
        shl    eax,16            ;on sauve les old int 8 et 9
        mov    ax,offset new9    ;et on met les notres (bad method
        mov    es:[9*4],eax      ;ici, faudrait utiliser l'int 21h)
        mov    al,36h     ;
        out    43h,al     ;
        mov    ax, 29829  ;1193180 / 40, car on veut 40 int par sec
        out    40h,al     ;
        mov    al,ah      ;on accelere le timer pour avoir 40
        out    40h,al     ;appels par seconde (on calcule 40 screens/s)
        sti
        ret
endp

close_screen proc
        mov    ax,3
        int    10h
        cli
        xor    ax,ax
        mov    es,ax
        mov    eax,old8
        mov    es:[8*4],eax
        mov    eax,old9
        mov    es:[9*4],eax
        mov    al,36h
        out    43h,al
        xor    ax,ax
        out    40h,al
        out    40h,al
        sti
        ret
endp

T_1 equ (    400+10*(22+15+31+23))
T_2 equ (T_1+400+10*(17+19+24+28+6+10))
T_3 equ (T_2+400+10*(16+25+26+21))
T_4 equ (T_3+400+10*(30+35+40+30+6+33+40))

calculate_screen proc
        call   clear_screen
        mov    ax,timing
        cmp    ax,T_1
        jae    cs2
        call   part1
        mov    ax,inc_valeur
        add    temps_part1,ax
        jmp    csf
cs2:    cmp    ax,T_2
        jae    cs3
        call   part2
        mov    ax,inc_valeur
        add    temps_part2,ax
        jmp    csf
cs3:    cmp    ax,T_3
        jae    cs4
        call   part3
        mov    ax,inc_valeur
        add    temps_part3,ax
        jmp    csf
cs4:    cmp    ax,T_4
        jae    cs5
        call   part4
        mov    ax,inc_valeur
        add    temps_part4,ax
        jmp    csf
cs5:    mov    all_over,1
csf:    mov    ax,inc_valeur
        add    timing,ax
        ret
endp

;on se contente de recopier le segment 'ecran' a l'ecran (!)
put_screen proc
        xor    si,si
        xor    di,di
        mov    ax,0a000h
        mov    es,ax
        mov    ax,ecran
        mov    ds,ax
        cld
        mov     cx,16000
        rep movsd
        ret
endp

;on clear le screen
clear_screen proc
        xor    di,di
        mov    ax,ecran
        mov    es,ax
        cld
        xor    eax,eax
        mov    cx,16000
        rep stosd
        ret
endp